import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.Border;

public class SudokuGUI {
    private JFrame frame;
    private JTextField[][] grid;

    private int[] spielfeld;
    private boolean loesungGefunden;

    /** 
     * Wird beim Klick auf den Button "Lösen" mit dem Parameter 0 aufgerufen
     * Enthält den rekursiven Backtracking-Code
     */
    private void loeseSudoku(int feld) {
        //# TODO: Implementiere den Code
    }

    /**
     * Soll true zurückgeben, wenn keine Sudoku-Regel verletzt wurde - sonst false.
     * ACHTUNG: 0 darf mehrfach in den Zeilen/Spalten/3x3-Blöcken vorkommen!
     */
    private boolean istFehlerfrei() {
        //# TODO: Implementiere den Code
        
        return true;
    }

    
    
    
    
    
    
    
    
    // Nachfolgend gibt es den vorgegebenen Code, an dem du nichts ändern musst.
    
    private void zeigeErgebnis() {
        for (int i = 0; i < 81; i++) {
            grid[i / 9][i % 9].setText(Integer.toString(spielfeld[i]));
        }
    }

    public SudokuGUI() {
        frame = new JFrame("Sudoku");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setLayout(new BorderLayout());

        JPanel gridPanel = new JPanel();
        gridPanel.setLayout(new GridLayout(9, 9));

        grid = new JTextField[9][9];
        Font font = new Font("SansSerif", Font.PLAIN, 24); 

        for (int row = 0; row < 9; row++) {
            for (int col = 0; col < 9; col++) {
                grid[row][col] = new JTextField();
                grid[row][col].setHorizontalAlignment(JTextField.CENTER);
                grid[row][col].setFont(font);

                // Bestimmen der Dicke der Ränder für die 3x3-Blöcke
                int top = (row % 3 == 0) ? 3 : 1;
                int left = (col % 3 == 0) ? 3 : 1;
                int bottom = (row == 8) ? 3 : 1;
                int right = (col == 8) ? 3 : 1;

                Border border = BorderFactory.createMatteBorder(top, left, bottom, right, Color.BLACK);
                grid[row][col].setBorder(border);

                gridPanel.add(grid[row][col]);
            }
        }

        JButton checkButton = new JButton("Lösen");
        checkButton.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    prepareSudokuSolver();
                }
            });

        frame.add(gridPanel, BorderLayout.CENTER);
        frame.add(checkButton, BorderLayout.SOUTH);

        frame.setSize(600, 600);
        frame.setVisible(true);
    }

    private void prepareSudokuSolver() {
        spielfeld = new int[81];
        loesungGefunden = false;

        for (int row = 0; row < 9; row++) {
            for (int col = 0; col < 9; col++) {
                String text = grid[row][col].getText();
                if (text.isEmpty()) {
                    spielfeld[row*9 + col] = 0; // Leere Felder als 0 behandeln
                } else {
                    try {
                        int zahl = Integer.parseInt(text);
                        if (zahl > 9 || zahl < 1) {
                            throw new NumberFormatException();
                        }
                        spielfeld[row*9 + col] = zahl;
                    } catch (NumberFormatException e) {
                        JOptionPane.showMessageDialog(frame, "Ungültiger Eingabewert!");
                        return;
                    }
                }
            }
        }

        loeseSudoku(0);
        if (!loesungGefunden) {
            JOptionPane.showMessageDialog(frame, "Keine Lösung gefunden!");
        }
    }

    private void setPuzzle(int[][] puzzle) {
        for (int row = 0; row < 9; row++) {
            for (int col = 0; col < 9; col++) {
                if (puzzle[row][col] != 0) {
                    grid[row][col].setText(String.valueOf(puzzle[row][col]));
                    grid[row][col].setEditable(false);
                    grid[row][col].setBackground(Color.LIGHT_GRAY);
                } else {
                    grid[row][col].setText("");
                    grid[row][col].setEditable(true);
                    grid[row][col].setBackground(Color.WHITE);
                }
            }
        }
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    new SudokuGUI();
                }
            });
    }
}